const maxN = 1000;
const m = 1000003;

var letters: array[0 .. maxN - 1] of array[0 .. maxN - 1] of char;
    word: array[0 .. 2 * maxN - 2] of char;
    N, i, j, initialLine, initialRow, length, line, row: longint;
    cnt: array[0 .. maxN - 1] of array[0 .. maxN - 1] of longint;

function getCount(line, row: longint): longint;
begin
    if (line < 0) or (row < 0) then
        getCount := 0
    else
        getCount := cnt[line][row];
end;

begin
    assign(input, 'line.dat');
    reset(input);
    assign(output, 'line.sol');
    rewrite(output);

    readln(N);
    for i := 0 to N - 1 do
    begin
        for j := 0 to N - 1 do
            read(letters[i][j]);
        readln;
    end;
    for i := 0 to 2 * N - 2 do
        read(word[i]);

    if letters[0][0] <> word[0] then
    begin
        writeln(0);
        exit;
    end;

    cnt[0][0] := 1;
    for i := 1 to 2 * N - 2 do
    begin
        if i < N then
        begin
            initialLine := 0;
            initialRow := i;
            length := i + 1;
        end else
        begin
            initialLine := i - N + 1;
            initialRow := N - 1;
            length := 2 * N - i - 1;
        end;
        for j := 0 to length - 1 do
        begin
            line := initialLine + j;
            row := initialRow - j;
            if letters[line][row] = word[i] then
                cnt[line][row] := (getCount(line - 1, row) + getCount(line, row - 1)) mod m
            else
                cnt[line][row] := 0;
        end;
    end;

    writeln(cnt[N - 1][N - 1]);
end.
