#define maxSize 1000000

#include <stdio.h>
#include <algorithm>

using namespace std;

int T, N, M, cols[maxSize], rows[maxSize], rowsIndex[maxSize + 1];

bool check()
{
    long long colSum = 0, rowSum = 0;
    for (int i = 0; i < N; i++)
        colSum += cols[i];
    for (int i = 0; i < M; i++)
        rowSum += rows[i];
    if (colSum != rowSum)
        return false;

    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j <= N; j++)
            rowsIndex[j] = 0;
        for (int j = 0; j < M; j++)
            rowsIndex[rows[j]]++;
        int pointer = 0;
        for (int j = 0; j <= N; j++)
            for (int k = 0; k < rowsIndex[j]; k++)
            {
                rows[pointer] = j;
                pointer++;
            }
        for (int j = M - 1; j >= M - cols[i]; j--)
        {
            if (rows[j] == 0)
                return false;
            rows[j]--;
        }
    }
    return true;
}

int main()
{
    freopen("puzzle.dat", "r", stdin);
    freopen("puzzle.sol", "w", stdout);

    scanf("%d", &T);
    for (int test = 0; test < T; test++)
    {
        scanf("%d %d", &N, &M);
        for (int i = 0; i < N; i++)
            scanf("%d", &cols[i]);
        for (int i = 0; i < M; i++)
            scanf("%d", &rows[i]);
        printf("%d\n", check() ? 1 : 0);
    }

    return 0;
}
