#define maxSize 1000000

#include <stdio.h>
#include <algorithm>

using namespace std;

int T, N, M, cols[maxSize], rows[maxSize];

bool check()
{
    long long colSum = 0, rowSum = 0;
    for (int i = 0; i < N; i++)
        colSum += cols[i];
    for (int i = 0; i < M; i++)
        rowSum += rows[i];
    if (colSum != rowSum)
        return false;

    if (M < N)
        for (int i = 0; i < N; i++)
        {
            sort(rows, rows + M);
            for (int j = M - 1; j >= M - cols[i]; j--)
            {
                if (rows[j] == 0)
                    return false;
                rows[j]--;
            }
        }
    else
        for (int i = 0; i < M; i++)
        {
            sort(cols, cols + N);
            for (int j = N - 1; j >= N - rows[i]; j--)
            {
                if (cols[j] == 0)
                    return false;
                cols[j]--;
            }
        }
    return true;
}

int main()
{
    freopen("puzzle.dat", "r", stdin);
    freopen("puzzle.sol", "w", stdout);

    scanf("%d", &T);
    for (int test = 0; test < T; test++)
    {
        scanf("%d %d", &N, &M);
        for (int i = 0; i < N; i++)
            scanf("%d", &cols[i]);
        for (int i = 0; i < M; i++)
            scanf("%d", &rows[i]);
        printf("%d\n", check() ? 1 : 0);
    }

    return 0;
}
