#define maxN 300
#define m 1000003

#include <stdio.h>

char letters[maxN][maxN];
char word[2 * maxN - 1];
int N, cnt[maxN][maxN][2 * maxN - 1];

inline int getCount(int i, int j, int k)
{
    if (i < 0 || j < 0)
        return 0;
    return cnt[i][j][k];
}

int main()
{
    freopen("line.dat", "r", stdin);
    freopen("line.sol", "w", stdout);

    scanf("%d\n", &N);
    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < N; j++)
            scanf("%c", &letters[i][j]);
        scanf("\n");
    }
    for (int i = 0; i < 2 * N - 1; i++)
        scanf("%c", &word[i]);

    if (letters[0][0] != word[0])
    {
        printf("0\n");
        return 0;
    }
    for (int i = 0; i < N; i++)
        for (int j = 0; j < N; j++)
            cnt[i][j][0] = 0;
    cnt[0][0][0] = 1;
    for (int k = 1; k < 2 * N - 1; k++)
        for (int i = 0; i < N; i++)
            for (int j = 0; j < N; j++)
            {
                if (letters[i][j] == word[k])
                {
                    cnt[i][j][k] = getCount(i - 1, j, k - 1) + getCount(i, j - 1, k - 1);
                    if (cnt[i][j][k] > m)
                        cnt[i][j][k] -= m;
                } else
                    cnt[i][j][k] = 0;
            }

    printf("%d\n", cnt[N - 1][N - 1][2 * N - 2]);
    return 0;
}
