#define maxN 1000
#define m 1000003

#include <stdio.h>

char letters[maxN][maxN];
char word[2 * maxN - 1];
int N, answer;

void cnt(int line, int row)
{
    if (letters[line][row] != word[line + row])
        return;
    if (line < N - 1)
        cnt(line + 1, row);
    if (row < N - 1)
        cnt(line, row + 1);
    if (line == N - 1 && row == N - 1)
    {
        answer++;
        if (answer > m)
            answer -= m;
    }
}

int main()
{
    freopen("line.dat", "r", stdin);
    freopen("line.sol", "w", stdout);

    scanf("%d\n", &N);
    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < N; j++)
            scanf("%c", &letters[i][j]);
        scanf("\n");
    }
    for (int i = 0; i < 2 * N - 1; i++)
        scanf("%c", &word[i]);

    cnt(0, 0);

    printf("%d\n", answer);
    return 0;
}
