#include <iostream>
#include <string>
#include <memory.h>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <fstream>
#include <queue>
#include <list>

using namespace std;
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for(int i=a;i<b;++i)
const int inf = 1000000001;
int x[200005], y[200005];
int xx[200005], yy[200005], rr[200005];
int n, m;
int r;
int get(int x1, int y1, int x2, int y2, int x, int y) {
    long long A, B, C;
    A = y2 - y1;
    B = x1 - x2;
    C = -A * x1 - B * y1;
    long long val = A * x + B * y + C;
    int is = 0;
    if (val > 0) is = 1; else if (val < 0) is = -1;
    return is;
}
bool check(int X, int Y) {
    int is = 0;
    for (int i = 0; i < n; ++i) {
        int c = get(x[i], y[i], x[i + 1], y[i + 1], X, Y);
        if (c != 0) {
            if (is == 0) is = c;
            else if (is != c) return false;
        }
    }
    return true;
}
pair < int, int > pts[2000000];
int all;
void add(int x, int y) {
    pts[all++] = make_pair(x, y);
}
int main() {
    freopen("trees.dat", "r", stdin);
    freopen("trees.sol", "w", stdout);
    
    //freopen("input.txt","r",stdin);
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) scanf("%d%d", &x[i], &y[i]);
    x[n] = x[0], y[n] = y[0];
    scanf("%d", &m);
    int ans = 0;
    long long sum = 0;
    for (int i = 0; i < m; ++i) {
        scanf("%d%d%d", &xx[i], &yy[i], &rr[i]);
        sum += 1LL * rr[i] * rr[i];
    }
    if (1LL * sum * n <= 100000000) {
        for (int i = 0; i < m; ++i) {
            int r = rr[i];
            for (int X = -r; X <= r; ++X) {
                for (int Y = -r; Y <= r; ++Y) {
                    if (X * X + Y * Y <= r * r) add(xx[i] + X, yy[i] + Y);
                }
            }
        }
        sort(pts, pts + all);
        for (int i = 0; i < all; ++i) {
            if (i != 0 && pts[i] == pts[i - 1]) continue;
            if (check(pts[i].first, pts[i].second)) ans++;
        }
        cout << ans << endl;
        return 0;
    }

    int maxx, minx, maxy, miny;
    maxx = minx = x[0];
    miny = maxy = y[0];
    for (int i = 1; i < n; ++i) {
        maxx = max(maxx, x[i]); minx = min(minx, x[i]);
        maxy = max(maxy, y[i]); miny = min(miny, y[i]);
    }

    for (int X = minx; X <= maxx; ++X) {
        for (int Y = miny; Y <= maxy; ++Y) {
            if (!check(X, Y)) continue;
            bool is = false;
            for (int i = 0; i < m; ++i) {
                if (1LL * (xx[i] - X) * (xx[i] - X) + 1LL * (yy[i] - Y) * (yy[i] - Y) <= 1LL * rr[i] * rr[i]) {
                    is = true;
                    break;
                }
            }
            ans += is;
        }
    }
    cout << ans << endl;
    return 0;
}

