#include <iostream>
#include <string>
#include <memory.h>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <vector>
#include <fstream>
#include <queue>
#include <list>

using namespace std;
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for(int i=a;i<b;++i)

const int MAXN = 100005;

int n;
int x[MAXN], y[MAXN];
int m;
int xx[MAXN], yy[MAXN];
int rr[MAXN];
bool good(long long x, long long y, long long r) {
    return (x * x + y * y <= r * r);
}

bool check(int x, int y) {
    for (int i = 0; i < n; ++i) {
        if (good(xx[i] - x, yy[i] - y, rr[i])) return true;
    }
    return false;
}

int main() {
    freopen("trees.dat", "r", stdin);
    freopen("trees.sol", "w", stdout);
   
   // freopen("input.txt","r",stdin);
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &x[i], &y[i]);
    }
    scanf("%d", &m);
    for (int i = 0; i < m; ++i) {
        scanf("%d%d%d", &xx[i], &yy[i], &rr[i]);
    }
    int maxx = x[0], minx = x[0], miny = y[0], maxy = y[0];
    for (int i = 1; i < n; ++i) {
        maxx = max(maxx, x[i]);
        maxy = max(maxy, y[i]);

        minx = min(minx, x[i]);
        miny = min(miny, y[i]);
    }
    int ans = 0;
    for (int cx = minx; cx <= maxx; ++cx) {
        for (int cy = miny; cy <= maxy; ++cy) {
            ans += check(cx, cy);
        }
    }
    printf("%d\n", ans);
    return 0;
}

